<?php

namespace App\Console\Commands;


use App\Models\UserData; 
use Illuminate\Support\Str; 
use GuzzleHttp\Client;

use Illuminate\Console\Command;

class SaveRandomUsername extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    //protected $signature = 'command:name';
    
    protected $signature = 'save:random-username';
    protected $description = 'Save a random username in the user_data table';


public function __construct()
    {
        parent::__construct();
    }


    /**
     * The console command description.
     *
     * @var string
     */
    //protected $description = 'Command description';

    /**
     * Execute the console command.
     *
     * @return int
     */
    public function handle()
    {
       $client = new Client(['verify' => false]);
       $url = "https://earthquake.usgs.gov/fdsnws/event/1/query?format=geojson&starttime=2024-08-30&latitude=30.552188&longitude=70.038733&maxradiuskm=1200";
       
       $response = $client->get($url);
       
       $data = json_decode($response->getBody(), true);
       
       $earthquakes = $data['features'];
       
       
       $randomUsername = 'useraa_' . Str::random(8);
       
       foreach ($earthquakes as $earthquake) {
           $mag = $earthquake['properties']['mag'];
           $place = $earthquake['properties']['place'];
           $time = $earthquake['properties']['time'];
           $sig = $earthquake['properties']['sig'];
           $nst = $earthquake['properties']['nst'];
           $dmin = $earthquake['properties']['dmin'];
           $gap = $earthquake['properties']['gap'];
           $magType = $earthquake['properties']['magType'];
           $title = $earthquake['properties']['title'];
           $type = $earthquake['geometry']['type'];
           $coordinates = $earthquake['geometry']['coordinates'];
           
          
           $coordinateString = '[' . implode(',', $coordinates) . ']';
           $placeParts = explode(',', $place);
           $country = trim(end($placeParts));

            if ($mag < 4) {
    $image = 'green_image.png';
    $icon = 'green_icon.png';
} elseif ($mag >= 4 && $mag <= 6) {
    $image = 'orange_image.png';
    $icon = 'orange_icon.png';
} else {
    $image = 'red_image.png';
    $icon = 'red_icon.png';
}
        
          
           
           UserData::create([
            'username' => $randomUsername,
            'mag' => $mag,
            'place' => $place,
            'time' => $time,
            'sig' => $sig,
            'nst' => $nst,
            'dmin' => $dmin,
            'gap' => $gap,
            'magType' => $magType,
            'title' => $title,
            'type' =>$type,
            'coordinates' =>$coordinateString,
            'country' => $country,
            'image' => $image,
            'icon' => $icon
            
        ]);
       }
       
       
        
        
         // Generate a random username
        

        // Save the username in the user_data table
        

        $this->info('Random username saved successfully!');
    }
}
